/*
 * ChaosExplorer source file
 * Copyright (C) 2002-2003 by Roland Riegel <feedback@roland-riegel.de>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * $Id$
 *
 */

#include "drawwidget.h"

DrawWidget::DrawWidget( QWidget* parent, const char* name )
	: QWidget( parent, name, Qt::WResizeNoErase | Qt::WRepaintNoErase )
{
	setCursor( Qt::crossCursor );
	setMouseTracking( true );
}

DrawWidget::~DrawWidget()
{
}

void DrawWidget::paintEvent( QPaintEvent* e )
{
	emit paint( e->rect() );
}

void DrawWidget::mousePressEvent( QMouseEvent* e )
{
	switch( e->button() )
	{
		case Qt::LeftButton:
			emit mouseDownLeft( e->pos() );
			break;
		case Qt::RightButton:
			emit mouseDownRight( e->pos() );
	}
}

void DrawWidget::mouseReleaseEvent( QMouseEvent* e )
{
	switch( e->button() )
	{
		case Qt::LeftButton:
			emit mouseUpLeft( e->pos() );
			break;
		case Qt::RightButton:
			emit mouseUpRight( e->pos() );
	}
}

void DrawWidget::mouseMoveEvent( QMouseEvent* e )
{
	emit mouseMove( e->pos() );
}

void DrawWidget::enterEvent( QEvent* e )
{
	emit mouseEnter();
}

void DrawWidget::leaveEvent( QEvent* e )
{
	emit mouseLeave();
}