/*
 * ChaosExplorer source file
 * Copyright (C) 2002-2003 by Roland Riegel <feedback@roland-riegel.de>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * $Id$
 *
 */

#if !defined(DRAWWIDGET_H)
#define DRAWWIDGET_H

#include <qwidget.h>

class DrawWidget : public QWidget
{
	Q_OBJECT
public:
	DrawWidget( QWidget* parent = 0, const char* name = 0 );
	~DrawWidget();

signals:
	void paint( const QRect& rect );
	void mouseDownLeft( const QPoint& point );
	void mouseDownRight( const QPoint& point );
	void mouseUpLeft( const QPoint& point );
	void mouseUpRight( const QPoint& point );
	void mouseMove( const QPoint& point );
	void mouseEnter();
	void mouseLeave();

private:
	void paintEvent( QPaintEvent* e );
	void mousePressEvent( QMouseEvent* e );
	void mouseReleaseEvent( QMouseEvent* e );
	void mouseMoveEvent( QMouseEvent* e );
	void enterEvent( QEvent* e );
	void leaveEvent( QEvent* e );
};

#endif // !defined(DRAWWIDGET_H)
