/*
 * ChaosExplorer source file
 * Copyright (C) 2002-2003 by Roland Riegel <feedback@roland-riegel.de>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * $Id$
 *
 */

#ifndef FEIGENBAUM_CALC_H
#define FEIGENBAUM_CALC_H

#include <qthread.h>
#include <qobject.h>

#include "vartypes.h"
#include "feigenbaum_calcinputdata.h"
#include "feigenbaum_calcresult.h"

namespace Feigenbaum
{
	class Calc : public QObject, public QThread
	{
		Q_OBJECT
	public:
		Calc( Handle<CalcInputData> input, Handle<CalcResult> output );
		~Calc();

		void stop();

		bool calcing();

	signals:
		void started();
		void stopped();
		void finished();
		void updated( const QRect& );

	private:
		void run();

		bool m_calcing;
		Handle<CalcInputData> m_input;
		Handle<CalcResult> m_output;

	};
}

#endif
