/*
 * ChaosExplorer source file
 * Copyright (C) 2002-2003 by Roland Riegel <feedback@roland-riegel.de>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * $Id$
 *
 */

#include "feigenbaum_calcresult.h"

#include <qpaintdevicemetrics.h>
#include <qprinter.h>

void Feigenbaum::CalcResult::setPixel( const IntPoint& point )
{
	QPainter painter( &m_pixmap );
	painter.setPen( Qt::black );
	painter.drawLine( point.x, point.y, point.x, point.y ); //painter.drawPoint( point.x, point.y );
}

QPixmap& Feigenbaum::CalcResult::pixmap()
{
	return m_pixmap;
}

void Feigenbaum::CalcResult::printPixmap( const QPrinter* printer )
{
	QPaintDeviceMetrics printer_metrics( printer );
	QPaintDeviceMetrics pixmap_metrics( &m_pixmap );

	int new_printer_width = pixmap_metrics.width() / pixmap_metrics.widthMM() * printer_metrics.widthMM();
	int new_printer_height = pixmap_metrics.height() / pixmap_metrics.heightMM() * printer_metrics.heightMM();

	if( pixmap_metrics.width() > new_printer_width )
	{
		new_printer_height *= (double) pixmap_metrics.width() / new_printer_width;
		new_printer_width = pixmap_metrics.width();
	}
	if( pixmap_metrics.height() > new_printer_height )
	{
		new_printer_width *= (double) pixmap_metrics.height() / new_printer_height;
		new_printer_height = pixmap_metrics.height();
	}

	QPainter painter( printer );
	painter.setWindow( 0, 0, new_printer_width, new_printer_height );
	painter.drawPixmap( 0, 0, m_pixmap );
}

void Feigenbaum::CalcResult::deleteData()
{
	m_pixmap.fill( Qt::white );
	emit update( m_pixmap.rect() );
}
