/*
 * ChaosExplorer source file
 * Copyright (C) 2002-2003 by Roland Riegel <feedback@roland-riegel.de>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * $Id$
 *
 */

#ifndef FEIGENBAUM_CALCRESULT_H
#define FEIGENBAUM_CALCRESULT_H

#include <qobject.h>
#include <qpixmap.h>
#include <qpainter.h>

#include "vartypes.h"

namespace Feigenbaum
{
	class CalcResult : public QObject
	{
		Q_OBJECT
	public:
		void setPixel( const IntPoint& point );

		QPixmap& pixmap();

		void printPixmap( const QPrinter* printer );

	public slots:
		void deleteData();

	signals:
		void update( const QRect& rect );

	private:
		QPixmap m_pixmap;

	};

}

#endif