/*
 * ChaosExplorer source file
 * Copyright (C) 2002-2003 by Roland Riegel <feedback@roland-riegel.de>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * $Id$
 *
 */

#ifndef MANDELBROT_CALCRESULT_H
#define MANDELBROT_CALCRESULT_H

#include <qobject.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qpainter.h>
#include <qprinter.h>
#include <qpaintdevicemetrics.h>
#include <qfileinfo.h>
#include <vector>
using std::vector;

#include "vartypes.h"

namespace Mandelbrot
{
	class CalcResult : public QObject
	{
		Q_OBJECT
	public:
		IntMatrix& resultMatrix();
		vector<QColor>& palette();

		QPixmap& pixmap();

		bool exportBitmap( QString fileName );
		void printPixmap( const QPrinter* printer );

		void resize( const IntSize& size );

	public slots:
		void rectPainted( const IntRect& rect );
		void deleteData();

	signals:
		void pixmapChanged( const QRect& rect );

	private:
		IntMatrix m_resultMatrix;
		vector<QColor> m_palette;
		QPixmap m_pixmap;
	};

}

#endif